/* sdlsfx.c: Creating the program's sound effects.
 *
 * Copyright (C) 2001-2006 by Brian Raiter, under the GNU General Public
 * License. No warranty. See COPYING for details.
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<SDL.h>
#include	"sdlgen.h"
#include	"../err.h"
#include	"../state.h"

//DKS - new
#include	<mikmod.h>
#include 	<sys/ioctl.h>
#include	<sys/soundcard.h>
#include	<unistd.h>
#include	<fcntl.h>

//DKS - don't need anymore
///* Some generic default settings for the audio output.
// */
//#define DEFAULT_SND_FMT		AUDIO_S16SYS
//#define DEFAULT_SND_FREQ	22050
//#define	DEFAULT_SND_CHAN	1

//DKS - new mikmod stuff for music:
#define NUMSONGS	5

// array holds all our loaded modules
MODULE *songs[NUMSONGS];

// This array holds the length in positions of the above songs.  It is necessary
// to have this because libmikmod is stupid and doesn't have a function to
// get the length of a loaded song.
int		songlengths[NUMSONGS];

// this is TRUE if modules were loaded properly at program startup, FALSE if not
static int music_initialized = FALSE;
// and this is TRUE if music is enabled or FALSE if disabled by user
static int music_enabled = TRUE;
//dks new what song in the songs[] array are we playing?
static int currentsong = 0;
static int gamemusicplaying = 0;


//DKS - modified to use mikmod
///* The data needed for each sound effect's wave.
// */
//typedef	struct sfxinfo {
//    Uint8	       *wave;		/* the actual wave data */
//    Uint32		len;		/* size of the wave data */
//    int			pos;		/* how much has been played already */
//    int			playing;	/* is the wave currently playing? */
//    char const	       *textsfx;	/* the onomatopoeia string */
//} sfxinfo;

typedef struct sfxinfo {
	SAMPLE	*sample;	/* mikmod sample format */
	int	playing;	/* is the sample currently playing? */
	int	voice;	/*what voice sample is playing on, if it's not a one-shot sound */
} sfxinfo;

//DKS - don't need this anymore.
///* The data needed to talk to the sound output device.
// */
//static SDL_AudioSpec	spec;

/* All of the sound effects.
 */
static sfxinfo		sounds[SND_COUNT];

/* TRUE if sound-playing has been enabled.
 */
static int		enabled = FALSE;

/* TRUE if the program is currently talking to a sound device.
 */
static int		hasaudio = FALSE;

/* The volume level.
 */
static int		volume = 100;	//overall volume 0 - 100
static int 		musicvolume = 20;	//volume of music 0 - 100 as percent of overal vol

//DKS - don't need this anymore.
///* The sound buffer size scaling factor.
// */
//static int		soundbufsize = 0;

//DKS - don't need anymore
//
///* Initialize the textual sound effects.
// */
//static void initonomatopoeia(void)
//{
//    sounds[SND_CHIP_LOSES].textsfx      = "\"Bummer\"";
//    sounds[SND_CHIP_WINS].textsfx       = "Tadaa!";
//    sounds[SND_TIME_OUT].textsfx        = "Clang!";
//    sounds[SND_TIME_LOW].textsfx        = "Ktick!";
//    sounds[SND_DEREZZ].textsfx		= "Bzont!";
//    sounds[SND_CANT_MOVE].textsfx       = "Mnphf!";
//    sounds[SND_IC_COLLECTED].textsfx    = "Chack!";
//    sounds[SND_ITEM_COLLECTED].textsfx  = "Slurp!";
//    sounds[SND_BOOTS_STOLEN].textsfx    = "Flonk!";
//    sounds[SND_TELEPORTING].textsfx     = "Bamff!";
//    sounds[SND_DOOR_OPENED].textsfx     = "Spang!";
//    sounds[SND_SOCKET_OPENED].textsfx   = "Clack!";
//    sounds[SND_BUTTON_PUSHED].textsfx   = "Click!";
//    sounds[SND_BOMB_EXPLODES].textsfx   = "Booom!";
//    sounds[SND_WATER_SPLASH].textsfx    = "Plash!";
//    sounds[SND_TILE_EMPTIED].textsfx    = "Whisk!";
//    sounds[SND_WALL_CREATED].textsfx    = "Chunk!";
//    sounds[SND_TRAP_ENTERED].textsfx    = "Shunk!";
//    sounds[SND_SKATING_TURN].textsfx    = "Whing!";
//    sounds[SND_SKATING_FORWARD].textsfx = "Whizz ...";
//    sounds[SND_SLIDING].textsfx         = "Drrrr ...";
//    sounds[SND_BLOCK_MOVING].textsfx    = "Scrrr ...";
//    sounds[SND_SLIDEWALKING].textsfx    = "slurp slurp ...";
//    sounds[SND_ICEWALKING].textsfx      = "snick snick ...";
//    sounds[SND_WATERWALKING].textsfx    = "plip plip ...";
//    sounds[SND_FIREWALKING].textsfx     = "crackle crackle ...";
//}

//DKS - don't need anymore
///* Display the onomatopoeia for the currently playing sound effect.
// * Only the first sound is used, since we can't display multiple
// * strings.
// */
//static void displaysoundeffects(unsigned long sfx, int display)
//{
//    unsigned long	flag;
//    int			i;
//
//    if (!display) {
//	setdisplaymsg(NULL, 0, 0);
//	return;
//    }
//
//    for (flag = 1, i = 0 ; flag ; flag <<= 1, ++i) {
//	if (sfx & flag) {
//	    setdisplaymsg(sounds[i].textsfx, 500, 10);
//	    return;
//	}
//    }
//}

//DKS - don't need anymore, but we will have a function called often in loops to update sounds
///* The callback function that is called by the sound driver to supply
// * the latest sound effects. All the sound effects are checked, and
// * the ones that are being played get another chunk of their sound
// * data mixed into the output buffer. When the end of a sound effect's
// * wave data is reached, the one-shot sounds are changed to be marked
// * as not playing, and the continuous sounds are looped.
// */
//static void sfxcallback(void *data, Uint8 *wave, int len)
//{
//    int	i, n;
//
//    (void)data;
//    memset(wave, spec.silence, len);
//    for (i = 0 ; i < SND_COUNT ; ++i) {
//	if (!sounds[i].wave)
//	    continue;
//	if (!sounds[i].playing)
//	    if (!sounds[i].pos || i >= SND_ONESHOT_COUNT)
//		continue;
//	n = sounds[i].len - sounds[i].pos;
//	if (n > len) {
//	    SDL_MixAudio(wave, sounds[i].wave + sounds[i].pos, len, volume);
//	    sounds[i].pos += len;
//	} else {
//	    SDL_MixAudio(wave, sounds[i].wave + sounds[i].pos, n, volume);
//	    sounds[i].pos = 0;
//	    if (i < SND_ONESHOT_COUNT) {
//		sounds[i].playing = FALSE;
//	    } else if (sounds[i].playing) {
//		while (len - n >= (int)sounds[i].len) {
//		    SDL_MixAudio(wave + n, sounds[i].wave, sounds[i].len,
//				 volume);
//		    n += sounds[i].len;
//		}
//		sounds[i].pos = len - n;
//		SDL_MixAudio(wave + n, sounds[i].wave, sounds[i].pos, volume);
//	    }
//	}
//    }
//}

//DKS - new
static void gp2x_set_volume(int leftVolume, int rightVolume)
{
    unsigned long soundDev = open("/dev/mixer", O_RDWR);
    if (soundDev)
    {
        int vol =(((leftVolume*0x50)/100)<<8)|((rightVolume*0x50)/100);
        ioctl(soundDev, SOUND_MIXER_WRITE_PCM, &vol);
        close(soundDev);
    }
}

/*
 * The exported functions.
 */

///* Activate or deactivate the sound system. When activating for the
// * first time, the connection to the sound device is established. When
// * deactivating, the connection is closed.
// */
//int setaudiosystem(int active)
//{
//    SDL_AudioSpec	des;
//    int			n;
//
//    if (!enabled)
//	return !active;
//
//    if (!active) {
//	if (hasaudio) {
//	    SDL_PauseAudio(TRUE);
//	    SDL_CloseAudio();
//	    hasaudio = FALSE;
//	}
//	return TRUE;
//    }
//
//    if (!SDL_WasInit(SDL_INIT_AUDIO)) {
//	if (SDL_InitSubSystem(SDL_INIT_AUDIO) < 0) {
//	    warn("Cannot initialize audio output: %s", SDL_GetError());
//	    return FALSE;
//	}
//    }
//
//    if (hasaudio)
//	return TRUE;
//
//    des.freq = DEFAULT_SND_FREQ;
//    des.format = DEFAULT_SND_FMT;
//    des.channels = DEFAULT_SND_CHAN;
//    des.callback = sfxcallback;
//    des.userdata = NULL;
//    for (n = 1 ; n <= des.freq / TICKS_PER_SECOND ; n <<= 1) ;
//    des.samples = (n << soundbufsize) >> 2;
//    if (SDL_OpenAudio(&des, &spec) < 0) {
//	warn("can't access audio output: %s", SDL_GetError());
//	return FALSE;
//    }
//    hasaudio = TRUE;
//    SDL_PauseAudio(FALSE);
//
//
//
//    return TRUE;
//}
/* Activate or deactivate the sound system. When activating for the
 * first time, the connection to the sound device is established. When
 * deactivating, the connection is closed.
 */
int setaudiosystem(int active)
{
    //SDL_AudioSpec	des;
    //int			n;

    if (!enabled)
	return !active;

    if (!active) {
	if (hasaudio) {
//	    SDL_PauseAudio(TRUE);
//	    SDL_CloseAudio();
		//dks new:
		if (Player_Active()) {
			Player_Stop();
		}
		MikMod_DisableOutput();
		
#ifdef PLATFORM_GP2X
		//set GP2X mixer to something reasonable when we exit.
		gp2x_set_volume(70, 70);
#endif

//		Mix_CloseAudio();
	    hasaudio = FALSE;
	}
	return TRUE;
    }

    if (!SDL_WasInit(SDL_INIT_AUDIO)) {
		if (SDL_InitSubSystem(SDL_INIT_AUDIO) < 0) {
		    warn("Cannot initialize audio output: %s", SDL_GetError());
		    return FALSE;
		} 
    }
    if (hasaudio)
	return TRUE;

//    des.freq = DEFAULT_SND_FREQ;
//    des.format = DEFAULT_SND_FMT;
//    des.channels = DEFAULT_SND_CHAN;
//    des.callback = sfxcallback;
//    des.userdata = NULL;
//    for (n = 1 ; n <= des.freq / TICKS_PER_SECOND ; n <<= 1) ;
//    des.samples = (n << soundbufsize) >> 2;
//    if (SDL_OpenAudio(&des, &spec) < 0) {
//	warn("can't access audio output: %s", SDL_GetError());
//	return FALSE;
//    }
    
//    if (Mix_OpenAudio(22050, AUDIO_S16SYS, 2, 512) < 0) {
//    		printf("Error initializing SDL_mixer: %s\n", Mix_GetError());
//    		return FALSE;
//	}
//	MikMod_EnableOutput();

#ifdef PLATFORM_GP2X
	// originally had 12, 13 seems to work better with only tiny tiny delay
	drv_oss.CommandLine("buffer=13,count=2");
#endif
	
	MikMod_RegisterDriver(&drv_oss);
	MikMod_RegisterLoader(&load_mod);
	MikMod_RegisterLoader(&load_s3m);
	
#ifndef PLATFORM_PC
	md_mixfreq = 22050;
#endif
	
	md_mode = DMODE_16BITS | DMODE_STEREO | DMODE_SOFT_MUSIC | DMODE_SOFT_SNDFX;

 	if (MikMod_Init("")) {
        warn("Could not initialize libmikmod, reason: %s\n",
                MikMod_strerror(MikMod_errno));
        return FALSE;
    }
    
    /* reserve 6 voices for sound effects */
    MikMod_SetNumVoices(-1, 6);

	/* get ready to play */
	MikMod_EnableOutput();

    //this must come before below call to setvolume
    hasaudio = TRUE;
	
	gp2x_set_volume(volume, volume);   

    md_volume =  128;	//this gets locked at 128
	
	md_musicvolume = musicvolume * 128 / 100;

//    SDL_PauseAudio(FALSE);

    return TRUE;
}

//DKS
///* Load a single wave file into memory. The wave data is converted to
// * the format expected by the sound device.
// */
//int loadsfxfromfile(int index, char const *filename)
//{
//    SDL_AudioSpec	specin;
//    SDL_AudioCVT	convert;
//    Uint8	       *wavein;
//    Uint8	       *wavecvt;
//    Uint32		lengthin;
//
//    if (!filename) {
//	freesfx(index);
//	return TRUE;
//    }
//
//    if (!enabled)
//	return FALSE;
//    if (!hasaudio)
//	if (!setaudiosystem(TRUE))
//	    return FALSE;
//
//    if (!SDL_LoadWAV(filename, &specin, &wavein, &lengthin)) {
//	warn("can't load %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
//
//    if (SDL_BuildAudioCVT(&convert,
//			  specin.format, specin.channels, specin.freq,
//			  spec.format, spec.channels, spec.freq) < 0) {
//	warn("can't create converter for %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
//    if (!(wavecvt = malloc(lengthin * convert.len_mult)))
//	memerrexit();
//    memcpy(wavecvt, wavein, lengthin);
//    SDL_FreeWAV(wavein);
//    convert.buf = wavecvt;
//    convert.len = lengthin;
//    if (SDL_ConvertAudio(&convert) < 0) {
//	warn("can't convert %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
//
//    freesfx(index);
//    SDL_LockAudio();
//    sounds[index].wave = convert.buf;
//    sounds[index].len = convert.len * convert.len_ratio;
//    sounds[index].pos = 0;
//    sounds[index].playing = FALSE;
//    SDL_UnlockAudio();
//
//    return TRUE;
//}
/* Load a single wave file into memory. The wave data is converted to
 * the format expected by the sound device.
 */
int loadsfxfromfile(int index, char const *filename)
{
//    SDL_AudioSpec	specin;
 //   SDL_AudioCVT	convert;
//    Uint8	       *wavein;
//    Uint8	       *wavecvt;
//    Uint32		lengthin;

    if (!filename) {
//	//dks
	if (sounds[index].sample) {
		freesfx(index);
	}
	return TRUE;
    }

    if (!enabled)
	return FALSE;
    if (!hasaudio)
	if (!setaudiosystem(TRUE))
	    return FALSE;

//    if (!SDL_LoadWAV(filename, &specin, &wavein, &lengthin)) {
//	warn("can't load %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
    sounds[index].sample = Sample_Load(filename);
    
    if (sounds[index].sample == NULL) {
	warn("can't load %s: MikMod error number %d", filename, MikMod_errno);
	return FALSE;
    } else {
    	if (index >= SND_ONESHOT_COUNT) {
			//this is a looping sound
			sounds[index].sample->flags |= SF_LOOP;
			sounds[index].sample->loopstart = 0;
			sounds[index].sample->loopend = sounds[index].sample->length - 1;
    	}
    }
//    if (SDL_BuildAudioCVT(&convert,
//			  specin.format, specin.channels, specin.freq,
//			  spec.format, spec.channels, spec.freq) < 0) {
//	warn("can't create converter for %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
//    if (!(wavecvt = malloc(lengthin * convert.len_mult)))
//	memerrexit();
//    memcpy(wavecvt, wavein, lengthin);
//    SDL_FreeWAV(wavein);
//    convert.buf = wavecvt;
//    convert.len = lengthin;
//    if (SDL_ConvertAudio(&convert) < 0) {
//	warn("can't convert %s: %s", filename, SDL_GetError());
//	return FALSE;
//    }
//
//    freesfx(index);
//    SDL_LockAudio();
//    sounds[index].wave = convert.buf;
//    sounds[index].len = convert.len * convert.len_ratio;
//    sounds[index].pos = 0;
//    sounds[index].playing = FALSE;
//    SDL_UnlockAudio();

    return TRUE;
}

//DKS - new
static int	loadmusic(void) {

	songs[0] = Player_Load("./music/chaozz_sunrise.s3m", 8, FALSE);
	songs[1] = Player_Load("./music/chaozz_c64rulez.mod", 4, FALSE);
	songs[2] = Player_Load("./music/am-fm_-_chip_n_roll.mod", 4, FALSE);
	songs[3] = Player_Load("./music/am-fm_-_0ldsk00l_w1z4rd.mod", 4, FALSE);
	songs[4] = Player_Load("./music/am-fm_-_biological_part1.mod", 4, FALSE);

	if (!songs[0] || !songs[1] || !songs[2] || !songs[3] || !songs[4]) {
		music_initialized = FALSE;
        warn("Could not initialize music, reason: %s\n",
                MikMod_strerror(MikMod_errno));
        music_initialized = FALSE;
	} else {
		music_initialized = TRUE;
	}

	int i;
	for (i = 0; i < NUMSONGS; ++i) {
		songs[i]->wrap = 0;
		songs[i]->loop = 0;
	}
	
	//DKS - For some reason, libmikmod doesn't appear to have a function to
	// tell how long a MOD is in positions.  I manually got these from Winamp,
	// LOL, so we can tell when it's time to move onto the next song
	// in updatesound()
	songlengths[0] = 10;
	songlengths[1] = 12;
	songlengths[2] = 22;
	songlengths[3] = 19;
	songlengths[4] = 23;
	
	return music_initialized;
}


//DKS this sets music volume to between 0 and 100, 0 doesn't allow songs to be played
// musicvolume is a percent of overall volume
void setmusicvolume(int newvol) {
	if (!hasaudio) {
		return;
	}

		if (newvol < 0) {
			return;
		} else if (newvol == 0) {
			musicvolume = 0;
			if (Player_Active()) {
				Player_Stop();
				MikMod_Update();
			}	
		} else {
			musicvolume = newvol;
			if (Player_Active()) {
				Player_SetVolume( musicvolume * md_volume / 100);
			}
			
		}
	
} 
	
//DKS new music handling stuff
void playgamesongs(void) {
	
	if (music_enabled) {
	 	if (currentsong == 0) {
	 		//start it on #1 if playing the menusong
	 		currentsong = 1;
	 	}
	 	
	 	if (!gamemusicplaying) {
	 		//game music starts once, and stays playing until quit back to menu
	 		gamemusicplaying = 1;
			Player_Start(songs[currentsong]);
			Player_SetVolume(musicvolume * md_volume / 100);
			Player_SetPosition(0);
	 	}
	}
}

//rotate the game song
void advancegamesong(void) {
	++currentsong;
	if (currentsong > 4) {
		// song 0 is for titlescreen, these songs, 1-4 are rotating game songs
		currentsong = 1;
	}		
}

//DKS new function gets called in main menu
void playmenusong(void) {
	currentsong = 0;
	if (music_enabled) {
		gamemusicplaying = 0;
		Player_Start(songs[0]);
		Player_SetVolume(musicvolume * md_volume / 100);
		Player_SetPosition(0);
	}
}

//DKS new function gets called if user disabled music on main menu
void disablemusic(void) {
	if (!hasaudio) {
		return;
	}

	if (Player_Active()) {
		Player_Stop();
	}

	music_enabled = 0;	
}

//DKS new function gets called if user disabled music on main menu
void enablemusic(void) {
	if (!hasaudio) {
		return;
	}
	
	music_enabled = 1;
	Player_Start(songs[currentsong]);
}


//DKS new function to tell if music is enabled or not (used in main menu)
int ismusicenabled(void) {
	return (music_enabled);
} 


///* Select the sounds effects to be played. sfx is a bitmask of sound
// * effect indexes. Any continuous sounds that are not included in sfx
// * are stopped. One-shot sounds that are included in sfx are
// * restarted.
// */
//void playsoundeffects(unsigned long sfx)
//{
//    unsigned long	flag;
//    int			i;
//
//    if (!hasaudio || !volume) {
//	displaysoundeffects(sfx, TRUE);
//	return;
//    }
//
//    SDL_LockAudio();
//    for (i = 0, flag = 1 ; i < SND_COUNT ; ++i, flag <<= 1) {
//	if (sfx & flag) {
//	    sounds[i].playing = TRUE;
//	    if (sounds[i].pos && i < SND_ONESHOT_COUNT)
//		sounds[i].pos = 0;
//	} else {
//	    if (i >= SND_ONESHOT_COUNT)
//		sounds[i].playing = FALSE;
//	}
//    }
//    SDL_UnlockAudio();
//}
void playsoundeffects(unsigned long sfx)
{
    unsigned long	flag;
    int			i;

    if (!hasaudio || !volume) {
	return;
    }

    for (i = 0, flag = 1 ; i < SND_COUNT ; ++i, flag <<= 1) {
	if (sfx & flag) {
		if (i < SND_ONESHOT_COUNT) {
			sounds[i].voice = Sample_Play(sounds[i].sample, 0, 0);
			Voice_SetPanning(sounds[i].voice, PAN_CENTER);
			Voice_SetVolume(sounds[i].voice, 256);
		} else
			// this is a looping sound
			if (sounds[i].playing) {
				continue;
			} else {
				sounds[i].playing = TRUE;
				sounds[i].voice = Sample_Play(sounds[i].sample, 0, 1);
				Voice_SetPanning(sounds[i].voice, PAN_CENTER);
				Voice_SetVolume(sounds[i].voice, 256);

			}
	} else if ((i >= SND_ONESHOT_COUNT) && (sounds[i].playing)) {
		// turn looping sound off
		Voice_Stop(sounds[i].voice);
		sounds[i].playing = FALSE;
		}
    }
}	


//
///* If action is negative, stop playing all sounds immediately.
// * Otherwise, just temporarily pause or unpause sound-playing.
// */
//void setsoundeffects(int action)
//{
//    int	i;
//
//    if (!hasaudio || !volume)
//	return;
//
//    if (action < 0) {
//	SDL_LockAudio();
//	for (i = 0 ; i < SND_COUNT ; ++i) {
//	    sounds[i].playing = FALSE;
//	    sounds[i].pos = 0;
//	}
//	SDL_UnlockAudio();
//    } else {
//	SDL_PauseAudio(!action);
//    }
//}
/* If action is negative, stop playing all sounds immediately.
 * Otherwise, just temporarily pause or unpause sound-playing.
 */
void setsoundeffects(int action)
{
    int	i;

    if (!hasaudio || !volume)
	return;

    if (action < 0) {
    	for (i = 0 ; i < SND_COUNT ; ++i) {
		    if ((sounds[i].playing) && (i >= SND_ONESHOT_COUNT)) {
		    sounds[i].playing = FALSE;
			Voice_Stop(sounds[i].voice);
		    }
    	}
	} else {
		if (!action) {
			if (music_enabled) {
				if (!Player_Paused()) {
					Player_TogglePause();
				}
			}
		} else {
			if (music_enabled) {
				if (Player_Paused()) {
					Player_TogglePause();
				}
			}
		}
    }
}

//DKS new
void _updatesound(void) {
	if (hasaudio) {
		MikMod_Update();
			
		if (music_enabled) {
			
			// are we at the end of a song?
			if (songs[currentsong]->sngpos == songlengths[currentsong]) {
				if (currentsong == 0) {
					//this is the main menu song, just loop it
					Player_Start(songs[currentsong]);
					Player_SetVolume(musicvolume * 128 / 100);
					Player_SetPosition(0);
					
				} else {
					advancegamesong();
					Player_Start(songs[currentsong]);
					Player_SetVolume(musicvolume * 128 / 100);
					Player_SetPosition(0);
				}
			}
		}
	}
}

//DKS modified to add music module freeing
///* Release all memory for the given sound effect.
// */
//void freesfx(int index)
//{
//    if (sounds[index].wave) {
//	SDL_LockAudio();
//	free(sounds[index].wave);
//	sounds[index].wave = NULL;
//	sounds[index].pos = 0;
//	sounds[index].playing = FALSE;
//	SDL_UnlockAudio();
//    }
//}
/* Release all memory for the given sound effect.
 */
void freesfx(int index)
{
	
	if (enabled) {
	    if (sounds[index].sample) {
			Sample_Free(sounds[index].sample);
			sounds[index].sample = NULL;
			sounds[index].playing = FALSE;
	    }
    
	}
	
}


//DKS modified
///* Set the current volume level to v. If display is true, the
// * new volume level is displayed to the user.
// */
//int setvolume(int v, int display)
//{
//    char	buf[16];
//
//    if (!hasaudio)
//	return FALSE;
//    if (v < 0)
//	v = 0;
//    else if (v > 10)
//	v = 10;
//    if (!volume && v)
//	displaysoundeffects(0, FALSE);
//    volume = (SDL_MIX_MAXVOLUME * v + 9) / 10;
//    if (display) {
//	sprintf(buf, "Volume: %d", v);
//	setdisplaymsg(buf, 1000, 1000);
//    }
//    return TRUE;
//}
/* Set the current volume level to v. If display is true, the
 * new volume level is displayed to the user.
 */
int setvolume(int v, int display)
{
    if (!hasaudio)
	return FALSE;
    if (v < 0)
	v = 0;
    else if (v > 100)
	v = 100;
   
    volume = v;
    gp2x_set_volume(volume, volume);
    return TRUE;
}



//DKS modified
///* Change the current volume level by delta. If display is true, the
// * new volume level is displayed to the user.
// */
//int changevolume(int delta, int display)
//{
//    return setvolume(((10 * volume) / SDL_MIX_MAXVOLUME) + delta, display);
//}
/* Change the current volume level by delta. If display is true, the
 * new volume level is displayed to the user.
 */
int changevolume(int delta, int display)
{
 
    setvolume(volume + delta, display);
 
	return TRUE;	
}

/* Shut down the sound system.
 */
static void shutdown(void)
{

    setaudiosystem(FALSE);

	int n;    
    for (n = 0 ; n < SND_COUNT ; ++n)
		 freesfx(n);	
	
	if (music_initialized) {
    	int x;
    	for (x = 0; x < NUMSONGS; ++x) {
	    	Player_Free(songs[x]);
	 	}

	}

    MikMod_Exit();
        
    if (SDL_WasInit(SDL_INIT_AUDIO))
		SDL_QuitSubSystem(SDL_INIT_AUDIO);
    hasaudio = FALSE;

}

//DKS - modified.  We're now explicity shutting down SDL systems ourselves, not
// with atexit()
///* Initialize the module. If silence is TRUE, then the program will
// * leave sound output disabled.
// */
//int _sdlsfxinitialize(int silence, int _soundbufsize)
//{
//    atexit(shutdown);
//    enabled = !silence;
//    soundbufsize = _soundbufsize;
//    initonomatopoeia();
//    if (enabled)
//	setaudiosystem(TRUE);
//    return TRUE;
//}
/* Initialize the module. If silence is TRUE, then the program will
 * leave sound output disabled.
 */
int _sdlsfxinitialize(int silence, int _soundbufsize)
{
	int i;
    sdlg.updatesoundfunc = _updatesound;

    enabled = !silence;
    if (enabled) {
		setaudiosystem(TRUE);
		loadmusic();
    }
	
    return TRUE;
}
